pipeline {
   agent any    
   stages {
       stage ('Checkout'){
          steps{
             checkout scm
          }
       }
	   
	   stage('Build') {
         steps {
            bat 'mvn clean package'
         }
      }
       
	   stage ('Run Tests'){
		parallel {
      stage('Unit Test & Coverage') {
         steps {
            bat 'mvn verify'
         }
      }
	  
	  stage('PLSQL Unit Testing') {
		steps {
       bat 'utplsql run  HR/Epsilon_231@//h1cbty-scan.cbgrus.uat2:1521/UPGD2_DBA_SERVICE.CBGRUS.UAT2  -f=ut_junit_reporter -o=junit_test_results.xml -f=ut_documentation_reporter -f=ut_coverage_sonar_reporter -o=coverage.xml -f=ut_sonar_test_reporter -o=test_results.xml -p=test_betwnstr_sonali'
	   
           }
		             post {
            always{
                 junit "junit_test_results.xml"
             }
          }
		 

        }

	  }}
	  
	  stage('Static Code Analysis') {
         steps {
            bat 'mvn sonar:sonar'
         }
      }
	  
	  
	  
	        
   }
   post {
	failure{
		mail bcc: '', body: "<br>Project: ${env.JOB_NAME} <br>Build Number: ${env.BUILD_NUMBER} <br> URL : ${env.BUILD_URL}" , cc: '', charset: 'UTF-8' , from: '', mimeType: 'text/html' , replyTo: '', subject: "ERROR CI: Project Name -> ${env.JOB_NAME}" , to: "sonali.pattanshetti@epsilon.com";
	}
	changed {
 mail bcc: '',body: "<br>Project: ${env.JOB_NAME} <br>Build Number: ${env.BUILD_NUMBER} <br> URL : ${env.BUILD_URL}", cc: '',charset: 'UTF-8', from: '',mimeType: 'text/html', replyTo: '', subject: "Build Status Changed: Project Name -> ${env.JOB_NAME}" , to: "sonali.pattanshetti@epsilon.com";
} 
   }
   
   stage('push to nexus'){
   steps{nexusArtifactUploader artifacts: [[artifactId: 'application1', classifier: '', file: 'target/spring-petclinic-2.2.0.BUILD-SNAPSHOT.jar', type: 'jar']], credentialsId: '199a0045-42ca-47b5-973f-bb804bb299b2', groupId: 'epsilon', nexusUrl: 'http://localhost:8081/nexus', nexusVersion: 'nexus3', protocol: 'http', repository: 'maven-releases', version: '1.0'}}
   
   
}